package guinand.mobapp.iuttpdessinintent;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Point;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.MotionEvent;
import android.view.View;
import android.view.WindowManager;

import java.util.ArrayList;

public class Dessin extends AppCompatActivity {

    MonDessin feuille;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // couplée au choix du style dans le fichier res/styles.xml,
        // cette ligne permet de masquer toutes les barres de navigation.
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
                WindowManager.LayoutParams.FLAG_FULLSCREEN);
        feuille = new MonDessin(this);
        setContentView(feuille);
    }
}

class MonDessin extends View implements View.OnClickListener, View.OnTouchListener {

    Paint monStyle, styleTexte;
    float largeurTrait = 5;
    float x, y;
    float rayon = 100;
    ArrayList<Point> centresCercles;
    Dessin d;

    public MonDessin(Dessin d) {
        super(d);
        this.d = d;
        setFocusable(true);
        init();
    }

    @Override
    public void onDraw(Canvas canvas) {
        canvas.drawColor(Color.WHITE);
        if(centresCercles.size() == 0) {
            canvas.drawText("Aucun cercle défini...", 200,100,styleTexte);
        } else {
            for (int c =0; c<centresCercles.size();c++)  {
                Point centre = centresCercles.get(c);
                canvas.drawCircle(centre.x, centre.y, rayon, monStyle);
            }
        }
    }

    private void init() {
        // arraylist
        centresCercles = new ArrayList<Point>();
        // evenements
        this.setOnClickListener(this);
        this.setOnTouchListener(this);
        // style pour les cercles
        monStyle = new Paint();
        monStyle.setAntiAlias(true);
        monStyle.setStyle(Paint.Style.STROKE);
        monStyle.setStrokeWidth(largeurTrait);
        monStyle.setColor(Color.RED);
        // style pour le texte
        styleTexte = new Paint();
        styleTexte.setColor(Color.GREEN);
        styleTexte.setTextSize(48f);
    }


    @Override
    public boolean onTouch(View view, MotionEvent motionEvent) {
        x = motionEvent.getX();
        y = motionEvent.getY();
        return false;
    }


    @Override
    public void onClick(View view) {
        Point p = new Point((int) x, (int) y);
        if (!interieurCercle((int)x, (int)y)) {
            centresCercles.add(p);
            this.invalidate();
        } else
            d.finish();
    }

    private boolean interieurCercle(int x, int y) {
        boolean trouve = false;
        int index = 0;
        while(!trouve && (index < centresCercles.size())) {
            if(distance(x,y,centresCercles.get(index)) <= rayon)
                trouve = true;
            else
                index++;
        }
        return trouve;
    }

    private int distance(int x, int y, Point p) {
        int distance = (int)(Math.sqrt((int)((p.x - x)*(p.x-x))+((p.y-y)*(p.y-y))));
        return distance;
    }
}