package guinand.mobapp.iuttpdessinintent;

import android.content.Intent;
import android.net.Uri;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import java.net.MalformedURLException;

public class Home extends AppCompatActivity {

    public final static String TEXT = "texte";
    public final static String MOTIF = "motif";
    public final static int CODE_COMPTE = 1;

    EditText etUrl, etText, etMotif;
    TextView tvresult;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_home);
        etUrl = findViewById(R.id.url);
        etText = findViewById(R.id.text);
        etMotif = findViewById(R.id.motif);
        tvresult = findViewById(R.id.tvresult);
    }

    public void ouvrirPage(View v) {
        Uri url;
        try {
            url = Uri.parse(etUrl.getText().toString());
        } catch(NullPointerException npe) {
            Toast.makeText(this,"URL non valide",Toast.LENGTH_SHORT).show();
            url = Uri.parse("http://www.ecosia.org");
        }
        Intent ouvrirIntent = new Intent(Intent.ACTION_VIEW,url);
        startActivity(ouvrirIntent);
    }

    public void compter(View v) {
        String texte = etText.getText().toString();
        String motif = etMotif.getText().toString();
        if(texte.matches("") || motif.matches("")) {
            Toast.makeText(this,"Il faut saisir texte et motif",Toast.LENGTH_SHORT).show();
        } else {
            Intent compteIntent = new Intent(this, Comptage.class);
            compteIntent.putExtra(TEXT,texte);
            compteIntent.putExtra(MOTIF,motif);
            startActivityForResult(compteIntent,CODE_COMPTE);
        }
    }

    public void dessin(View v) {
        Intent intentDessin = new Intent(this,Dessin.class);
        startActivity(intentDessin);
    }


    public void quit(View v) {
        Toast.makeText(this,"Bye bye",Toast.LENGTH_SHORT).show();
        this.finish();
    }

    @Override
    public void onActivityResult(int code, int resultcode, Intent theIntent) {
        if((code == CODE_COMPTE) && (resultcode == RESULT_OK)) {
            int nbOccurrences = theIntent.getIntExtra(Comptage.COMPTE,0);
            tvresult.setText("Nombre d'occurrences du motif : "+nbOccurrences);
        }
    }


}
